{% extends "fim-json-legend/response.html.jinja" %}

{% block response %}
  <div class="container my-4">
    <h1>FIM JSON Legende</h1>

    <section>
      <button
        class="btn btn-primary"
        type="button"
        data-bs-toggle="collapse"
        data-bs-target="#input-data"
        aria-expanded="false"
        aria-controls="input-data"
      >
        JSON Daten Anzeigen/Verbergen
      </button>

      <div class="collapse mt-3" id="input-data">
        <div class="card card-body text-bg-light">
          <pre class="mb-0">{{ input_data }}</pre>
        </div>
      </div>
    </section>

    {% macro render_placeholder(identifier) %}
      <div class="accordion-item">
        <h2 class="accordion-header">
          <button
            class="accordion-button text-secondary collapsed"
            type="button"
            data-bs-toggle="collapse"
            data-bs-target="#{{ identifier|replace(".", "_") }}-collapse"
            aria-expanded="false"
            aria-controls="{{ identifier|replace(".", "_") }}-collapse"
          >
            {{ identifier }} - Unbekanntes Element
          </button>
        </h2>
        <div
          id="{{ identifier|replace(".", "_") }}-collapse"
          class="accordion-collapse collapse"
        >
          <div class="accordion-body">Keine Daten gefunden.</div>
        </div>
      </div>
    {% endmacro %}

    {% macro render_field(field) %}
      <div class="accordion-item">
        <h2 class="accordion-header">
          <button
            class="accordion-button collapsed"
            type="button"
            data-bs-toggle="collapse"
            data-bs-target="#{{ field.fim_id }}V{{ field.fim_version|replace(".", "_") }}-collapse"
            aria-expanded="false"
            aria-controls="{{ field.fim_id }}V{{ field.fim_version|replace(".", "_") }}-collapse"
          >
            {{ field.fim_id }}V{{ field.fim_version }} - {{ field.name }}
          </button>
        </h2>
        <div
          id="{{ field.fim_id }}V{{ field.fim_version|replace(".", "_") }}-collapse"
          class="accordion-collapse collapse"
        >
          <div class="accordion-body">
            <dl class="row">
              <dt class="col-sm-3">Definition</dt>
              <dd class="col-sm-9">{{ field.definition or "-" }}</dd>

              <dt class="col-sm-3">Beschreibung</dt>
              <dd class="col-sm-9">{{ field.beschreibung or "-" }}</dd>

              <dt class="col-sm-3">Ersteller</dt>
              <dd class="col-sm-9">{{ field.status_gesetzt_durch or "-" }}</dd>

              <dt class="col-sm-3">Feldart</dt>
              <dd class="col-sm-9">{{ field.feldart.value }}</dd>

              <dt class="col-sm-3">Datentyp</dt>
              <dd class="col-sm-9">{{ field.datentyp.value }}</dd>
            </dl>

            <a
              class="link-underline link-underline-opacity-0 link-underline-opacity-75-hover"
              href="/fields/{{ field.namespace }}/{{ field.fim_id }}/{{ field.fim_version }}"
              target="_blank"
              aria-label="Zur Detailseite im Sammelrepository (öffnet in neuem Tab)"
            >
              Zur Detailseite im Sammelrepository
            </a>
          </div>
        </div>
      </div>
    {% endmacro %}

    {% macro render_group(group) %}
      <div class="accordion-item">
        <h2 class="accordion-header">
          <button
            class="accordion-button collapsed"
            type="button"
            data-bs-toggle="collapse"
            data-bs-target="#{{ group.fim_id }}V{{ group.fim_version|replace(".", "_") }}-collapse"
            aria-expanded="false"
            aria-controls="{{ group.fim_id }}V{{ group.fim_version|replace(".", "_") }}-collapse"
          >
            {{ group.fim_id }}V{{ group.fim_version }} - {{ group.name }}
          </button>
        </h2>
        <div
          id="{{ group.fim_id }}V{{ group.fim_version|replace(".", "_") }}-collapse"
          class="accordion-collapse collapse"
        >
          <div class="accordion-body">
            <dl class="row">
              <dt class="col-sm-3">Definition</dt>
              <dd class="col-sm-9">{{ group.definition or "-" }}</dd>

              <dt class="col-sm-3">Beschreibung</dt>
              <dd class="col-sm-9">{{ group.beschreibung or "-" }}</dd>

              <dt class="col-sm-3">Ersteller</dt>
              <dd class="col-sm-9">{{ group.status_gesetzt_durch or "-" }}</dd>
            </dl>

            <a
              class="link-underline link-underline-opacity-0 link-underline-opacity-75-hover"
              href="/groups/{{ group.namespace }}/{{ group.fim_id }}/{{ group.fim_version }}"
              target="_blank"
              aria-label="Zur Detailseite im Sammelrepository (öffnet in neuem Tab)"
            >
              Zur Detailseite im Sammelrepository
            </a>
          </div>
        </div>
      </div>
    {% endmacro %}

    {% if groups|length > 0 %}
      <section>
        <h2 class="my-4">Datenfeldgruppen</h2>
        <div class="accordion" id="groups">
          {% for identifier, group in groups.items() %}
            {% if group %}
              {{ render_group(group) }}
            {% else %}
              {{ render_placeholder(identifier) }}
            {% endif %}
          {% endfor %}
        </div>
      </section>
    {% endif %}

    {% if fields|length > 0 %}
      <section>
        <h2 class="my-4">Datenfelder</h2>
        <div class="accordion" id="fields">
          {% for identifier, field in fields.items() %}
            {% if field %}
              {{ render_field(field) }}
            {% else %}
              {{ render_placeholder(identifier) }}
            {% endif %}
          {% endfor %}
        </div>
      </section>
    {% endif %}
  </div>
{% endblock %}
